#[doc = "Register `ACR_DATA` reader"]
pub struct R(crate::R<ACR_DATA_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<ACR_DATA_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<ACR_DATA_SPEC>> for R {
    fn from(reader: crate::R<ACR_DATA_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `ACR_DATA` writer"]
pub struct W(crate::W<ACR_DATA_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<ACR_DATA_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<ACR_DATA_SPEC>> for W {
    fn from(writer: crate::W<ACR_DATA_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `DATAL` reader - Data\\[63:48\\]"]
pub struct DATAL_R(crate::FieldReader<u16, u16>);
impl DATAL_R {
    pub(crate) fn new(bits: u16) -> Self {
        DATAL_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for DATAL_R {
    type Target = crate::FieldReader<u16, u16>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `DATAL` writer - Data\\[63:48\\]"]
pub struct DATAL_W<'a> {
    w: &'a mut W,
}
impl<'a> DATAL_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xffff) | (value as u32 & 0xffff);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:15 - Data\\[63:48\\]"]
    #[inline(always)]
    pub fn datal(&self) -> DATAL_R {
        DATAL_R::new((self.bits & 0xffff) as u16)
    }
}
impl W {
    #[doc = "Bits 0:15 - Data\\[63:48\\]"]
    #[inline(always)]
    pub fn datal(&mut self) -> DATAL_W {
        DATAL_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Acceptance Code Register ? Data\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [acr_data](index.html) module"]
pub struct ACR_DATA_SPEC;
impl crate::RegisterSpec for ACR_DATA_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [acr_data::R](R) reader structure"]
impl crate::Readable for ACR_DATA_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [acr_data::W](W) writer structure"]
impl crate::Writable for ACR_DATA_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets ACR_DATA to value 0"]
impl crate::Resettable for ACR_DATA_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
